Subject: RE: bug#17362: 24.4.50; inconsistent key notation: `ESC' vs `<ESC>'

From: Drew Adams <[email-masked]>
Date: Tue, 29 Apr 2014 12:38:00 -0700 (PDT)

> > And you write <left>, using the Lisp symbol name `left', because what
> > is printed on the keyboard key is an arrow, not "Left".  And yet for
> > <next>, the manual refers to it as both <next> and <PageDown> (in
> > Emacs 20 it was referred to as (only) <NEXT>).
> 
> I simply never saw a keyboard with a "next" key, so I don't know how
> it is labeled.  I left those as they were because of that.

<next> is how Emacs calls the "PageDown" key.  You did not leave that
as <next>.  Or maybe you meant that you left it as <PageDown> because
it is never labeled `next'?

> > These are inconsistencies within the manual, IMO.  They complicate
> > understanding unnecessarily.
> 
> They are not inconsistencies to me, because there's a reason for
> selecting each spelling, and I explained that reasoning.  Others are
> welcome to come up with different schemes, if they want, but I think
> in general too drastic changes should be avoided, because people are
> used to see "TAB" and "ESC".

TAB and ESC is also how Emacs (UI/help) refers to those, so no problem
there.

> > > I disagree.  The manual should make it easier for the reader to
> > > identify the keys it talks about.  For that reason, using the keys'
> > > labels is IMO more useful and efficient than using their lowercase
> > > variants.
> >
> > See above.  The manual can mention commonly used key labels, to help
> > users make connections.  But it makes little sense for the manual
> > to represent these keys differently in key sequences from the way
> > Emacs itself represents them.
> 
> If you mention the labels in just one place, it is as if you didn't
> mention them at all.  It's a large manual, and no one reads the
> section about why the keys are named like they are. 

Cross references.

> Most readers want
> to read what directly pertains to the subject they need now, and
> little else.  So the key sequences in the manual need to use a
> consistent naming scheme throughout, and not just in some obscure
> subsubsubsection.

The consistent naming scheme is the one Emacs itself uses.  It is
what users are used to seeing from Emacs.  It is what users will
see when they go back to the UI from the manual.

A "consistent" naming scheme that sometimes bases the name on a
key label and sometimes bases it on a Lisp symbol, and so on, is
unnecessarily complicated.  You can give a reasonable reason why
you named this or that key the way you did in the manual, but if
the reasoning has to go through multiple possibilities it is
unecessarily complicated.

Users should not need to know what the complicated rule is (or to
look it up, in the lone manual location where it is explained).
They should not wonder why sometimes this is done and sometimes
that, even if you have a good explanation for it.

> > > > > I only fixed inconsistencies in the manual, without any relation to
> > > > > what Emacs says in help mode.
> > > >
> > > > You fixed only some inconsistencies in the manual, but that is OK
> > > > for this bug report.  It is inconsistent to use <BACKSPACE> sometimes
> > > > and <Backspace> other times, <DELETE> and <Delete>, <left> and <Home>,
> > > > and so on.
> > >
> > > There should be only these variants in the manual:
> > >   <BACKSPACE>  <Delete>  <left> <Home>
> 
> Sorry, that was incorrect: it should be <LEFT>, in all caps.  The
> others are correct.

On my keyboard, "Backspace" is as much a label as are "Delete" and
"Home".  And I have a pretty common, standard keyboard.  You will perhaps
argue that keyboards change over time and differ according to location.
Exactly.

The most that can and should be said wrt keyboard key labels is to give
some examples: `DEL' and <backspace> (which are not the same) are
sometimes labeled "Backspace".  <next> is sometimes labeled "Page Down".
<left> is sometimes labeled with a left-pointing arrow.  And so on.

If Emacs itself can refer to a key as <next> then so can the Emacs
manual.  Emacs does not jump up every time it writes <next> and say
that this key might be labeled "PageDown", "Page Down", or "PageDwn"
on your keyboard.  And neither should the manual.  It is enough to
have a short section of the manual that talks about this - key labels
vs Emacs key-sequence notation.

> > There are lots of occurrences of <Backspace>.
> 
> Before my changes, yes.  Now I see only one, in the Glossary.

OK.